#ifndef LOGIN_H
#define LOGIN_H

#include <QMainWindow>
#include <QPixmap>
#include <QMessageBox>
#include <QDebug>
#include <QGraphicsDropShadowEffect>
#include <QEvent>
#include <QPainter>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QMovie>

#include "mainwidget.h"
#include "signup.h"
#include "datamanager.h"

QT_BEGIN_NAMESPACE
namespace Ui { class Login; }
QT_END_NAMESPACE

class Login : public QMainWindow
{
    Q_OBJECT

public:
    explicit Login(QWidget *parent = nullptr);
    ~Login();
    void paintEvent(QPaintEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void mousePressEvent(QMouseEvent *event);
    void new_closebutton(QPushButton* btn, QString position,QSize size);

signals:
    void signin_request(QString username,QString password);
    void Register(QString username,QString password);

private slots:
    void on_btn_signin_clicked();
    void on_btn_signup_clicked();
    void on_close_btn_clicked();

    void signin_response(bool result);
    void signup_response(bool result);
    void show_login_ui();
    void slot_Register(QString username,QString password);
    void connected();
    void disconnected();
    void exit_client();

private:
    Ui::Login *ui;
    QPoint point;
    QString user,passwd;
    static Login login_instance;
    Login *login;
    Signup *signup;
    MainWidget *mainwidget;
    DataManager *datamanager;
    bool connect_flag = false;

};

#endif // LOGIN_H
