#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <QWidget>
#include <QListWidgetItem>
#include <QMessageBox>
#include <QTime>
#include <QFile>
#include <QProgressDialog>
#include <QDir>
#include <QFileDialog>
#include <QScrollBar>
#include <QKeyEvent>

namespace Ui {
class MainWidget;
}

class MainWidget : public QWidget
{
    Q_OBJECT

public:
    explicit MainWidget(QString username,QWidget *parent = nullptr);
    ~MainWidget();
    void sendFile(QString filePath,QString filename,QString name = "");
    bool eventFilter(QObject *target, QEvent *event);

signals:
    void send_text(QString text);
    void send_file_to_all(QByteArray file);
    void send_file_private(QByteArray file,QString name);
    void exit_client();
    void account_cancellation(QString username);

private slots:
    void on_send_text_clicked();

    void on_save_btn_clicked();

    void on_send_btn_clicked();

    void on_name_list_itemDoubleClicked(QListWidgetItem *item);

    void on_exit_btn_clicked();

    void on_stop_clicked();

private:
    Ui::MainWidget *ui;
    QString username;
};

#endif // MAINWIDGET_H
